/*!
 * @fileOverview TouchSwipe - jQuery Plugin
 * @version 1.6.18
 *
 * @author Matt Bryson http://www.github.com/mattbryson
 * @see https://github.com/mattbryson/TouchSwipe-Jquery-Plugin
 * @see http://labs.rampinteractive.co.uk/touchSwipe/
 * @see http://plugins.jquery.com/project/touchSwipe
 * @license
 * Copyright (c) 2010-2015 Matt Bryson
 * Dual licensed under the MIT or GPL Version 2 licenses.
 *
 */
!function(e){"function"==typeof define&&define.amd&&define.amd.jQuery?define(["jquery"],e):"undefined"!=typeof module&&module.exports?e(require("jquery")):e(jQuery)}((function(e){"use strict";var n="left",t="up",r="ontouchstart"in window,i=window.navigator.msPointerEnabled&&!window.PointerEvent&&!r,l=(window.PointerEvent||window.navigator.msPointerEnabled)&&!r;function o(n){return!n||void 0!==n.allowPageScroll||void 0===n.swipe&&void 0===n.swipeStatus||(n.allowPageScroll="none"),void 0!==n.click&&void 0===n.tap&&(n.tap=n.click),n||(n={}),n=e.extend({},e.fn.swipe.defaults,n),this.each((function(){var t=e(this),r=t.data("TouchSwipe");r||(r=new a(this,n),t.data("TouchSwipe",r))}))}function a(o,a){a=e.extend({},a);var u=r||l||!a.fallbackToMouseEvents,c=u?l?i?"MSPointerDown":"pointerdown":"touchstart":"mousedown",s=u?l?i?"MSPointerMove":"pointermove":"touchmove":"mousemove",p=u?l?i?"MSPointerUp":"pointerup":"touchend":"mouseup",h=u?l?"mouseleave":null:"mouseleave",f=l?i?"MSPointerCancel":"pointercancel":"touchcancel",d=0,g=null,w=null,v=0,T=0,m=0,y=1,E=0,S=0,b=null,x=e(o),O="start",M=0,P={},D=0,L=0,R=0,k=0,A=0,I=null,U=null;try{x.on(c,j),x.on(f,_)}catch(n){e.error("events not supported "+c+","+f+" on jQuery.swipe")}function j(r){if(!0!==x.data("TouchSwipe_intouch")&&!(e(r.target).closest(a.excludedElements,x).length>0)){var i=r.originalEvent?r.originalEvent:r;if(!i.pointerType||"mouse"!=i.pointerType||0!=a.fallbackToMouseEvents){var l,o,u=i.touches,c=u?u[0]:i;return O="start",u?M=u.length:!1!==a.preventDefaultEvents&&r.preventDefault(),d=0,g=null,w=null,S=null,v=0,T=0,m=0,y=1,E=0,(o={}).left=ue(n),o.right=ue("right"),o.up=ue(t),o.down=ue("down"),b=o,te(),le(0,c),!u||M===a.fingers||"all"===a.fingers||G()?(D=he(),2==M&&(le(1,u[1]),T=m=se(P[0].start,P[1].start)),(a.swipeStatus||a.pinchStatus)&&(l=F(i,O))):l=!1,!1===l?(F(i,O="cancel"),l):(a.hold&&(U=setTimeout(e.proxy((function(){x.trigger("hold",[i.target]),a.hold&&(l=a.hold.call(x,i,i.target))}),this),a.longTapThreshold)),ie(!0),null)}}}function N(r){var i=r.originalEvent?r.originalEvent:r;if("end"!==O&&"cancel"!==O&&!re()){var l,o,u,c,s,p=i.touches,h=oe(p?p[0]:i);if(L=he(),p&&(M=p.length),a.hold&&clearTimeout(U),O="move",2==M&&(0==T?(le(1,p[1]),T=m=se(P[0].start,P[1].start)):(oe(p[1]),m=se(P[0].end,P[1].end),P[0].end,P[1].end,S=y<1?"out":"in"),y=(m/T*1).toFixed(2),E=Math.abs(T-m)),M===a.fingers||"all"===a.fingers||!p||G()){if(g=pe(h.start,h.end),function(e,r){if(!1===a.preventDefaultEvents)return;if("none"===a.allowPageScroll)e.preventDefault();else{var i="auto"===a.allowPageScroll;switch(r){case n:(a.swipeLeft&&i||!i&&"horizontal"!=a.allowPageScroll)&&e.preventDefault();break;case"right":(a.swipeRight&&i||!i&&"horizontal"!=a.allowPageScroll)&&e.preventDefault();break;case t:(a.swipeUp&&i||!i&&"vertical"!=a.allowPageScroll)&&e.preventDefault();break;case"down":(a.swipeDown&&i||!i&&"vertical"!=a.allowPageScroll)&&e.preventDefault()}}}(r,w=pe(h.last,h.end)),c=h.start,s=h.end,d=Math.round(Math.sqrt(Math.pow(s.x-c.x,2)+Math.pow(s.y-c.y,2))),v=ce(),function(e,n){if("none"==e)return;n=Math.max(n,ae(e)),b[e].distance=n}(g,d),l=F(i,O),!a.triggerOnTouchEnd||a.triggerOnTouchLeave){var f=!0;if(a.triggerOnTouchLeave){var x={left:(u=(o=e(o=this)).offset()).left,right:u.left+o.outerWidth(),top:u.top,bottom:u.top+o.outerHeight()};f=function(e,n){return e.x>n.left&&e.x<n.right&&e.y>n.top&&e.y<n.bottom}(h.end,x)}!a.triggerOnTouchEnd&&f?O=C("move"):a.triggerOnTouchLeave&&!f&&(O=C("end")),"cancel"!=O&&"end"!=O||F(i,O)}}else F(i,O="cancel");!1===l&&F(i,O="cancel")}}function H(e){var n=e.originalEvent?e.originalEvent:e,t=n.touches;if(t){if(t.length&&!re())return function(e){R=he(),k=e.touches.length+1}(n),!0;if(t.length&&re())return!0}return re()&&(M=k),L=he(),v=ce(),z()||!Y()?F(n,O="cancel"):a.triggerOnTouchEnd||!1===a.triggerOnTouchEnd&&"move"===O?(!1!==a.preventDefaultEvents&&!1!==e.cancelable&&e.preventDefault(),F(n,O="end")):!a.triggerOnTouchEnd&&$()?X(n,O="end","tap"):"move"===O&&F(n,O="cancel"),ie(!1),null}function _(){M=0,L=0,D=0,T=0,m=0,y=1,te(),ie(!1)}function q(e){var n=e.originalEvent?e.originalEvent:e;a.triggerOnTouchLeave&&F(n,O=C("end"))}function Q(){x.off(c,j),x.off(f,_),x.off(s,N),x.off(p,H),h&&x.off(h,q),ie(!1)}function C(e){var n=e,t=V(),r=Y(),i=z();return!t||i?n="cancel":!r||"move"!=e||a.triggerOnTouchEnd&&!a.triggerOnTouchLeave?!r&&"end"==e&&a.triggerOnTouchLeave&&(n="cancel"):n="end",n}function F(e,n){var t,i=e.touches;return(Z()&&B()||B())&&(t=X(e,n,"swipe")),(W()&&G()||G())&&!1!==t&&(t=X(e,n,"pinch")),ne()&&ee()&&!1!==t?t=X(e,n,"doubletap"):v>a.longTapThreshold&&d<10&&a.longTap&&!1!==t?t=X(e,n,"longtap"):1!==M&&r||!(isNaN(d)||d<a.threshold)||!$()||!1===t||(t=X(e,n,"tap")),"cancel"===n&&_(),"end"===n&&(i&&i.length||_()),t}function X(r,i,l){var o;if("swipe"==l){if(x.trigger("swipeStatus",[i,g||null,d||0,v||0,M,P,w]),a.swipeStatus&&!1===(o=a.swipeStatus.call(x,r,i,g||null,d||0,v||0,M,P,w)))return!1;if("end"==i&&Z()){if(clearTimeout(I),clearTimeout(U),x.trigger("swipe",[g,d,v,M,P,w]),a.swipe&&!1===(o=a.swipe.call(x,r,g,d,v,M,P,w)))return!1;switch(g){case n:x.trigger("swipeLeft",[g,d,v,M,P,w]),a.swipeLeft&&(o=a.swipeLeft.call(x,r,g,d,v,M,P,w));break;case"right":x.trigger("swipeRight",[g,d,v,M,P,w]),a.swipeRight&&(o=a.swipeRight.call(x,r,g,d,v,M,P,w));break;case t:x.trigger("swipeUp",[g,d,v,M,P,w]),a.swipeUp&&(o=a.swipeUp.call(x,r,g,d,v,M,P,w));break;case"down":x.trigger("swipeDown",[g,d,v,M,P,w]),a.swipeDown&&(o=a.swipeDown.call(x,r,g,d,v,M,P,w))}}}if("pinch"==l){if(x.trigger("pinchStatus",[i,S||null,E||0,v||0,M,y,P]),a.pinchStatus&&!1===(o=a.pinchStatus.call(x,r,i,S||null,E||0,v||0,M,y,P)))return!1;if("end"==i&&W())switch(S){case"in":x.trigger("pinchIn",[S||null,E||0,v||0,M,y,P]),a.pinchIn&&(o=a.pinchIn.call(x,r,S||null,E||0,v||0,M,y,P));break;case"out":x.trigger("pinchOut",[S||null,E||0,v||0,M,y,P]),a.pinchOut&&(o=a.pinchOut.call(x,r,S||null,E||0,v||0,M,y,P))}}return"tap"==l?"cancel"!==i&&"end"!==i||(clearTimeout(I),clearTimeout(U),ee()&&!ne()?(A=he(),I=setTimeout(e.proxy((function(){A=null,x.trigger("tap",[r.target]),a.tap&&(o=a.tap.call(x,r,r.target))}),this),a.doubleTapThreshold)):(A=null,x.trigger("tap",[r.target]),a.tap&&(o=a.tap.call(x,r,r.target)))):"doubletap"==l?"cancel"!==i&&"end"!==i||(clearTimeout(I),clearTimeout(U),A=null,x.trigger("doubletap",[r.target]),a.doubleTap&&(o=a.doubleTap.call(x,r,r.target))):"longtap"==l&&("cancel"!==i&&"end"!==i||(clearTimeout(I),A=null,x.trigger("longtap",[r.target]),a.longTap&&(o=a.longTap.call(x,r,r.target)))),o}function Y(){var e=!0;return null!==a.threshold&&(e=d>=a.threshold),e}function z(){var e=!1;return null!==a.cancelThreshold&&null!==g&&(e=ae(g)-d>=a.cancelThreshold),e}function V(){return!a.maxTimeThreshold||!(v>=a.maxTimeThreshold)}function W(){var e=J(),n=K(),t=null===a.pinchThreshold||E>=a.pinchThreshold;return e&&n&&t}function G(){return!!(a.pinchStatus||a.pinchIn||a.pinchOut)}function Z(){var e=V(),n=Y(),t=J(),r=K();return!z()&&r&&t&&n&&e}function B(){return!!(a.swipe||a.swipeStatus||a.swipeLeft||a.swipeRight||a.swipeUp||a.swipeDown)}function J(){return M===a.fingers||"all"===a.fingers||!r}function K(){return 0!==P[0].end.x}function $(){return!!a.tap}function ee(){return!!a.doubleTap}function ne(){if(null==A)return!1;var e=he();return ee()&&e-A<=a.doubleTapThreshold}function te(){R=0,k=0}function re(){var e=!1;R&&(he()-R<=a.fingerReleaseThreshold&&(e=!0));return e}function ie(e){x&&(!0===e?(x.on(s,N),x.on(p,H),h&&x.on(h,q)):(x.off(s,N,!1),x.off(p,H,!1),h&&x.off(h,q,!1)),x.data("TouchSwipe_intouch",!0===e))}function le(e,n){var t={start:{x:0,y:0},last:{x:0,y:0},end:{x:0,y:0}};return t.start.x=t.last.x=t.end.x=n.pageX||n.clientX,t.start.y=t.last.y=t.end.y=n.pageY||n.clientY,P[e]=t,t}function oe(e){var n=void 0!==e.identifier?e.identifier:0,t=function(e){return P[e]||null}(n);return null===t&&(t=le(n,e)),t.last.x=t.end.x,t.last.y=t.end.y,t.end.x=e.pageX||e.clientX,t.end.y=e.pageY||e.clientY,t}function ae(e){if(b[e])return b[e].distance}function ue(e){return{direction:e,distance:0}}function ce(){return L-D}function se(e,n){var t=Math.abs(e.x-n.x),r=Math.abs(e.y-n.y);return Math.round(Math.sqrt(t*t+r*r))}function pe(e,r){if(l=r,(i=e).x==l.x&&i.y==l.y)return"none";var i,l,o=function(e,n){var t=e.x-n.x,r=n.y-e.y,i=Math.atan2(r,t),l=Math.round(180*i/Math.PI);return l<0&&(l=360-Math.abs(l)),l}(e,r);return o<=45&&o>=0?n:o<=360&&o>=315?n:o>=135&&o<=225?"right":o>45&&o<135?"down":t}function he(){return(new Date).getTime()}this.enable=function(){return this.disable(),x.on(c,j),x.on(f,_),x},this.disable=function(){return Q(),x},this.destroy=function(){Q(),x.data("TouchSwipe",null),x=null},this.option=function(n,t){if("object"==typeof n)a=e.extend(a,n);else if(void 0!==a[n]){if(void 0===t)return a[n];a[n]=t}else{if(!n)return a;e.error("Option "+n+" does not exist on jQuery.swipe.options")}return null}}e.fn.swipe=function(n){var t=e(this),r=t.data("TouchSwipe");if(r&&"string"==typeof n){if(r[n])return r[n].apply(r,Array.prototype.slice.call(arguments,1));e.error("Method "+n+" does not exist on jQuery.swipe")}else if(r&&"object"==typeof n)r.option.apply(r,arguments);else if(!(r||"object"!=typeof n&&n))return o.apply(this,arguments);return t},e.fn.swipe.version="1.6.18",e.fn.swipe.defaults={fingers:1,threshold:75,cancelThreshold:null,pinchThreshold:20,maxTimeThreshold:null,fingerReleaseThreshold:250,longTapThreshold:500,doubleTapThreshold:200,swipe:null,swipeLeft:null,swipeRight:null,swipeUp:null,swipeDown:null,swipeStatus:null,pinchIn:null,pinchOut:null,pinchStatus:null,click:null,tap:null,doubleTap:null,longTap:null,hold:null,triggerOnTouchEnd:!0,triggerOnTouchLeave:!1,allowPageScroll:"auto",fallbackToMouseEvents:!0,excludedElements:".noSwipe",preventDefaultEvents:!0},e.fn.swipe.phases={PHASE_START:"start",PHASE_MOVE:"move",PHASE_END:"end",PHASE_CANCEL:"cancel"},e.fn.swipe.directions={LEFT:n,RIGHT:"right",UP:t,DOWN:"down",IN:"in",OUT:"out"},e.fn.swipe.pageScroll={NONE:"none",HORIZONTAL:"horizontal",VERTICAL:"vertical",AUTO:"auto"},e.fn.swipe.fingers={ONE:1,TWO:2,THREE:3,FOUR:4,FIVE:5,ALL:"all"}}));